From 90b7941629df8c3e541ec9931ab7c49311724d6c Mon Sep 17 00:00:00 2001
From: David Lehman <dlehman@redhat.com>
Date: Wed, 18 Sep 2013 18:50:49 -0500
Subject: [PATCH 6/7] Add some documentation.

For now, things are not set up to auto-generate the docs at build time.
---
 doc/Makefile              | 153 ++++++++++++++++++++++++
 doc/blivet.devicelibs.rst |  75 ++++++++++++
 doc/blivet.formats.rst    |  91 +++++++++++++++
 doc/blivet.rst            | 179 ++++++++++++++++++++++++++++
 doc/conf.py               | 291 ++++++++++++++++++++++++++++++++++++++++++++++
 doc/index.rst             |  23 ++++
 doc/intro.rst             | 197 +++++++++++++++++++++++++++++++
 doc/modules.rst           |   7 ++
 8 files changed, 1016 insertions(+)
 create mode 100644 doc/Makefile
 create mode 100644 doc/blivet.devicelibs.rst
 create mode 100644 doc/blivet.formats.rst
 create mode 100644 doc/blivet.rst
 create mode 100644 doc/conf.py
 create mode 100644 doc/index.rst
 create mode 100644 doc/intro.rst
 create mode 100644 doc/modules.rst

diff --git a/doc/Makefile b/doc/Makefile
new file mode 100644
index 0000000..68bfbdb
--- /dev/null
+++ b/doc/Makefile
@@ -0,0 +1,153 @@
+# Makefile for Sphinx documentation
+#
+
+# You can set these variables from the command line.
+SPHINXOPTS    =
+SPHINXBUILD   = sphinx-build
+PAPER         =
+BUILDDIR      = _build
+
+# Internal variables.
+PAPEROPT_a4     = -D latex_paper_size=a4
+PAPEROPT_letter = -D latex_paper_size=letter
+ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
+# the i18n builder cannot share the environment and doctrees with the others
+I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
+
+.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext
+
+help:
+	@echo "Please use \`make <target>' where <target> is one of"
+	@echo "  html       to make standalone HTML files"
+	@echo "  dirhtml    to make HTML files named index.html in directories"
+	@echo "  singlehtml to make a single large HTML file"
+	@echo "  pickle     to make pickle files"
+	@echo "  json       to make JSON files"
+	@echo "  htmlhelp   to make HTML files and a HTML help project"
+	@echo "  qthelp     to make HTML files and a qthelp project"
+	@echo "  devhelp    to make HTML files and a Devhelp project"
+	@echo "  epub       to make an epub"
+	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
+	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
+	@echo "  text       to make text files"
+	@echo "  man        to make manual pages"
+	@echo "  texinfo    to make Texinfo files"
+	@echo "  info       to make Texinfo files and run them through makeinfo"
+	@echo "  gettext    to make PO message catalogs"
+	@echo "  changes    to make an overview of all changed/added/deprecated items"
+	@echo "  linkcheck  to check all external links for integrity"
+	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
+
+clean:
+	-rm -rf $(BUILDDIR)/*
+
+html:
+	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
+
+dirhtml:
+	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."
+
+singlehtml:
+	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
+	@echo
+	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."
+
+pickle:
+	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
+	@echo
+	@echo "Build finished; now you can process the pickle files."
+
+json:
+	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
+	@echo
+	@echo "Build finished; now you can process the JSON files."
+
+htmlhelp:
+	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
+	@echo
+	@echo "Build finished; now you can run HTML Help Workshop with the" \
+	      ".hhp project file in $(BUILDDIR)/htmlhelp."
+
+qthelp:
+	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
+	@echo
+	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
+	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
+	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Blivet.qhcp"
+	@echo "To view the help file:"
+	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Blivet.qhc"
+
+devhelp:
+	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
+	@echo
+	@echo "Build finished."
+	@echo "To view the help file:"
+	@echo "# mkdir -p $$HOME/.local/share/devhelp/Blivet"
+	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Blivet"
+	@echo "# devhelp"
+
+epub:
+	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
+	@echo
+	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."
+
+latex:
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo
+	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
+	@echo "Run \`make' in that directory to run these through (pdf)latex" \
+	      "(use \`make latexpdf' here to do that automatically)."
+
+latexpdf:
+	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
+	@echo "Running LaTeX files through pdflatex..."
+	$(MAKE) -C $(BUILDDIR)/latex all-pdf
+	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."
+
+text:
+	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
+	@echo
+	@echo "Build finished. The text files are in $(BUILDDIR)/text."
+
+man:
+	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
+	@echo
+	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."
+
+texinfo:
+	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
+	@echo
+	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
+	@echo "Run \`make' in that directory to run these through makeinfo" \
+	      "(use \`make info' here to do that automatically)."
+
+info:
+	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
+	@echo "Running Texinfo files through makeinfo..."
+	make -C $(BUILDDIR)/texinfo info
+	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."
+
+gettext:
+	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
+	@echo
+	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."
+
+changes:
+	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
+	@echo
+	@echo "The overview file is in $(BUILDDIR)/changes."
+
+linkcheck:
+	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
+	@echo
+	@echo "Link check complete; look for any errors in the above output " \
+	      "or in $(BUILDDIR)/linkcheck/output.txt."
+
+doctest:
+	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
+	@echo "Testing of doctests in the sources finished, look at the " \
+	      "results in $(BUILDDIR)/doctest/output.txt."
diff --git a/doc/blivet.devicelibs.rst b/doc/blivet.devicelibs.rst
new file mode 100644
index 0000000..bdbf2ae
--- /dev/null
+++ b/doc/blivet.devicelibs.rst
@@ -0,0 +1,75 @@
+devicelibs Package
+==================
+
+:mod:`btrfs` Module
+-------------------
+
+.. automodule:: blivet.devicelibs.btrfs
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`crypto` Module
+--------------------
+
+.. automodule:: blivet.devicelibs.crypto
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`dm` Module
+----------------
+
+.. automodule:: blivet.devicelibs.dm
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`edd` Module
+-----------------
+
+.. automodule:: blivet.devicelibs.edd
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`loop` Module
+------------------
+
+.. automodule:: blivet.devicelibs.loop
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`lvm` Module
+-----------------
+
+.. automodule:: blivet.devicelibs.lvm
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`mdraid` Module
+--------------------
+
+.. automodule:: blivet.devicelibs.mdraid
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`mpath` Module
+-------------------
+
+.. automodule:: blivet.devicelibs.mpath
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`swap` Module
+------------------
+
+.. automodule:: blivet.devicelibs.swap
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
diff --git a/doc/blivet.formats.rst b/doc/blivet.formats.rst
new file mode 100644
index 0000000..c8b6c03
--- /dev/null
+++ b/doc/blivet.formats.rst
@@ -0,0 +1,91 @@
+formats Package
+===============
+
+:mod:`formats` Package
+----------------------
+
+.. automodule:: blivet.formats
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`biosboot` Module
+----------------------
+
+.. automodule:: blivet.formats.biosboot
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`disklabel` Module
+-----------------------
+
+.. automodule:: blivet.formats.disklabel
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`dmraid` Module
+--------------------
+
+.. automodule:: blivet.formats.dmraid
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`fs` Module
+----------------
+
+.. automodule:: blivet.formats.fs
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`luks` Module
+------------------
+
+.. automodule:: blivet.formats.luks
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`lvmpv` Module
+-------------------
+
+.. automodule:: blivet.formats.lvmpv
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`mdraid` Module
+--------------------
+
+.. automodule:: blivet.formats.mdraid
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`multipath` Module
+-----------------------
+
+.. automodule:: blivet.formats.multipath
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`prepboot` Module
+----------------------
+
+.. automodule:: blivet.formats.prepboot
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`swap` Module
+------------------
+
+.. automodule:: blivet.formats.swap
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
diff --git a/doc/blivet.rst b/doc/blivet.rst
new file mode 100644
index 0000000..e9886cc
--- /dev/null
+++ b/doc/blivet.rst
@@ -0,0 +1,179 @@
+blivet Package
+==============
+
+:mod:`blivet` Package
+---------------------
+
+.. automodule:: blivet.__init__
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`arch` Module
+------------------
+
+.. automodule:: blivet.arch
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`dasd` Module
+------------------
+
+.. automodule:: blivet.dasd
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`deviceaction` Module
+--------------------------
+
+.. automodule:: blivet.deviceaction
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`devicefactory` Module
+---------------------------
+
+.. automodule:: blivet.devicefactory
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`devices` Module
+---------------------
+
+.. automodule:: blivet.devices
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`devicetree` Module
+------------------------
+
+.. automodule:: blivet.devicetree
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`errors` Module
+--------------------
+
+.. automodule:: blivet.errors
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`fcoe` Module
+------------------
+
+.. automodule:: blivet.fcoe
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`flags` Module
+-------------------
+
+.. automodule:: blivet.flags
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`iscsi` Module
+-------------------
+
+.. automodule:: blivet.iscsi
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`partitioning` Module
+--------------------------
+
+.. automodule:: blivet.partitioning
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`partspec` Module
+----------------------
+
+.. automodule:: blivet.partspec
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`platform` Module
+----------------------
+
+.. automodule:: blivet.platform
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`pyudev` Module
+--------------------
+
+.. automodule:: blivet.pyudev
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`size` Module
+------------------
+
+.. automodule:: blivet.size
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`storage_log` Module
+-------------------------
+
+.. automodule:: blivet.storage_log
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`tsort` Module
+-------------------
+
+.. automodule:: blivet.tsort
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`udev` Module
+------------------
+
+.. automodule:: blivet.udev
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`util` Module
+------------------
+
+.. automodule:: blivet.util
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+:mod:`zfcp` Module
+------------------
+
+.. automodule:: blivet.zfcp
+    :members:
+    :undoc-members:
+    :show-inheritance:
+
+Subpackages
+-----------
+
+.. toctree::
+
+    blivet.devicelibs
+    blivet.formats
+
diff --git a/doc/conf.py b/doc/conf.py
new file mode 100644
index 0000000..a1dda21
--- /dev/null
+++ b/doc/conf.py
@@ -0,0 +1,291 @@
+# -*- coding: utf-8 -*-
+#
+# Blivet documentation build configuration file, created by
+# sphinx-quickstart on Wed Sep 18 14:37:01 2013.
+#
+# This file is execfile()d with the current directory set to its containing dir.
+#
+# Note that not all possible configuration values are present in this
+# autogenerated file.
+#
+# All configuration values have a default; values that are commented out
+# serve to show the default.
+
+import sys, os
+
+# If extensions (or modules to document with autodoc) are in another directory,
+# add these directories to sys.path here. If the directory is relative to the
+# documentation root, use os.path.abspath to make it absolute, like shown here.
+sys.path.insert(0, os.path.abspath('..'))
+
+# -- General configuration -----------------------------------------------------
+
+# If your documentation needs a minimal Sphinx version, state it here.
+#needs_sphinx = '1.0'
+
+# Add any Sphinx extension module names here, as strings. They can be extensions
+# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
+extensions = ['sphinx.ext.autodoc', 'sphinx.ext.intersphinx', 'sphinx.ext.todo', 'sphinx.ext.coverage']
+
+# Add any paths that contain templates here, relative to this directory.
+templates_path = ['_templates']
+
+# The suffix of source filenames.
+source_suffix = '.rst'
+
+# The encoding of source files.
+#source_encoding = 'utf-8-sig'
+
+# The master toctree document.
+master_doc = 'index'
+
+# General information about the project.
+project = u'Blivet'
+copyright = u'2013, David Lehman'
+
+# The version info for the project you're documenting, acts as replacement for
+# |version| and |release|, also used in various other places throughout the
+# built documents.
+#
+# The short X.Y version.
+version = '0.22'
+# The full version, including alpha/beta/rc tags.
+release = '0.22'
+
+# The language for content autogenerated by Sphinx. Refer to documentation
+# for a list of supported languages.
+#language = None
+
+# There are two options for replacing |today|: either, you set today to some
+# non-false value, then it is used:
+#today = ''
+# Else, today_fmt is used as the format for a strftime call.
+#today_fmt = '%B %d, %Y'
+
+# List of patterns, relative to source directory, that match files and
+# directories to ignore when looking for source files.
+exclude_patterns = ['_build']
+
+# The reST default role (used for this markup: `text`) to use for all documents.
+#default_role = None
+
+# If true, '()' will be appended to :func: etc. cross-reference text.
+#add_function_parentheses = True
+
+# If true, the current module name will be prepended to all description
+# unit titles (such as .. function::).
+#add_module_names = True
+
+# If true, sectionauthor and moduleauthor directives will be shown in the
+# output. They are ignored by default.
+#show_authors = False
+
+# The name of the Pygments (syntax highlighting) style to use.
+pygments_style = 'sphinx'
+
+# A list of ignored prefixes for module index sorting.
+#modindex_common_prefix = []
+
+autoclass_content = 'both'
+
+
+# -- Options for HTML output ---------------------------------------------------
+
+# The theme to use for HTML and HTML Help pages.  See the documentation for
+# a list of builtin themes.
+html_theme = 'default'
+
+# Theme options are theme-specific and customize the look and feel of a theme
+# further.  For a list of options available for each theme, see the
+# documentation.
+#html_theme_options = {}
+
+# Add any paths that contain custom themes here, relative to this directory.
+#html_theme_path = []
+
+# The name for this set of Sphinx documents.  If None, it defaults to
+# "<project> v<release> documentation".
+#html_title = None
+
+# A shorter title for the navigation bar.  Default is the same as html_title.
+#html_short_title = None
+
+# The name of an image file (relative to this directory) to place at the top
+# of the sidebar.
+#html_logo = None
+
+# The name of an image file (within the static path) to use as favicon of the
+# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
+# pixels large.
+#html_favicon = None
+
+# Add any paths that contain custom static files (such as style sheets) here,
+# relative to this directory. They are copied after the builtin static files,
+# so a file named "default.css" will overwrite the builtin "default.css".
+html_static_path = ['_static']
+
+# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
+# using the given strftime format.
+#html_last_updated_fmt = '%b %d, %Y'
+
+# If true, SmartyPants will be used to convert quotes and dashes to
+# typographically correct entities.
+#html_use_smartypants = True
+
+# Custom sidebar templates, maps document names to template names.
+#html_sidebars = {}
+
+# Additional templates that should be rendered to pages, maps page names to
+# template names.
+#html_additional_pages = {}
+
+# If false, no module index is generated.
+#html_domain_indices = True
+
+# If false, no index is generated.
+#html_use_index = True
+
+# If true, the index is split into individual pages for each letter.
+#html_split_index = False
+
+# If true, links to the reST sources are added to the pages.
+#html_show_sourcelink = True
+
+# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
+#html_show_sphinx = True
+
+# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
+#html_show_copyright = True
+
+# If true, an OpenSearch description file will be output, and all pages will
+# contain a <link> tag referring to it.  The value of this option must be the
+# base URL from which the finished HTML is served.
+#html_use_opensearch = ''
+
+# This is the file name suffix for HTML files (e.g. ".xhtml").
+#html_file_suffix = None
+
+# Output file base name for HTML help builder.
+htmlhelp_basename = 'Blivetdoc'
+
+
+# -- Options for LaTeX output --------------------------------------------------
+
+latex_elements = {
+# The paper size ('letterpaper' or 'a4paper').
+#'papersize': 'letterpaper',
+
+# The font size ('10pt', '11pt' or '12pt').
+#'pointsize': '10pt',
+
+# Additional stuff for the LaTeX preamble.
+#'preamble': '',
+}
+
+# Grouping the document tree into LaTeX files. List of tuples
+# (source start file, target name, title, author, documentclass [howto/manual]).
+latex_documents = [
+  ('index', 'Blivet.tex', u'Blivet Documentation',
+   u'David Lehman', 'manual'),
+]
+
+# The name of an image file (relative to this directory) to place at the top of
+# the title page.
+#latex_logo = None
+
+# For "manual" documents, if this is true, then toplevel headings are parts,
+# not chapters.
+#latex_use_parts = False
+
+# If true, show page references after internal links.
+#latex_show_pagerefs = False
+
+# If true, show URL addresses after external links.
+#latex_show_urls = False
+
+# Documents to append as an appendix to all manuals.
+#latex_appendices = []
+
+# If false, no module index is generated.
+#latex_domain_indices = True
+
+
+# -- Options for manual page output --------------------------------------------
+
+# One entry per manual page. List of tuples
+# (source start file, name, description, authors, manual section).
+man_pages = [
+    ('index', 'blivet', u'Blivet Documentation',
+     [u'David Lehman'], 1)
+]
+
+# If true, show URL addresses after external links.
+#man_show_urls = False
+
+
+# -- Options for Texinfo output ------------------------------------------------
+
+# Grouping the document tree into Texinfo files. List of tuples
+# (source start file, target name, title, author,
+#  dir menu entry, description, category)
+texinfo_documents = [
+  ('index', 'Blivet', u'Blivet Documentation',
+   u'David Lehman', 'Blivet', 'One line description of project.',
+   'Miscellaneous'),
+]
+
+# Documents to append as an appendix to all manuals.
+#texinfo_appendices = []
+
+# If false, no module index is generated.
+#texinfo_domain_indices = True
+
+# How to display URL addresses: 'footnote', 'no', or 'inline'.
+#texinfo_show_urls = 'footnote'
+
+
+# -- Options for Epub output ---------------------------------------------------
+
+# Bibliographic Dublin Core info.
+epub_title = u'Blivet'
+epub_author = u'David Lehman'
+epub_publisher = u'David Lehman'
+epub_copyright = u'2013, David Lehman'
+
+# The language of the text. It defaults to the language option
+# or en if the language is not set.
+#epub_language = ''
+
+# The scheme of the identifier. Typical schemes are ISBN or URL.
+#epub_scheme = ''
+
+# The unique identifier of the text. This can be a ISBN number
+# or the project homepage.
+#epub_identifier = ''
+
+# A unique identification for the text.
+#epub_uid = ''
+
+# A tuple containing the cover image and cover page html template filenames.
+#epub_cover = ()
+
+# HTML files that should be inserted before the pages created by sphinx.
+# The format is a list of tuples containing the path and title.
+#epub_pre_files = []
+
+# HTML files shat should be inserted after the pages created by sphinx.
+# The format is a list of tuples containing the path and title.
+#epub_post_files = []
+
+# A list of files that should not be packed into the epub file.
+#epub_exclude_files = []
+
+# The depth of the table of contents in toc.ncx.
+#epub_tocdepth = 3
+
+# Allow duplicate toc entries.
+#epub_tocdup = True
+
+
+# Example configuration for intersphinx: refer to the Python standard library.
+intersphinx_mapping = {'http://docs.python.org/': None}
diff --git a/doc/index.rst b/doc/index.rst
new file mode 100644
index 0000000..4a5b677
--- /dev/null
+++ b/doc/index.rst
@@ -0,0 +1,23 @@
+.. Blivet documentation master file, created by
+   sphinx-quickstart on Wed Sep 18 14:37:01 2013.
+   You can adapt this file completely to your liking, but it should at least
+   contain the root `toctree` directive.
+
+Welcome to Blivet's documentation!
+==================================
+
+Contents:
+
+.. toctree::
+   :maxdepth: 2
+
+   intro
+   modules
+
+Indices and tables
+==================
+
+* :ref:`genindex`
+* :ref:`modindex`
+* :ref:`search`
+
diff --git a/doc/intro.rst b/doc/intro.rst
new file mode 100644
index 0000000..e377597
--- /dev/null
+++ b/doc/intro.rst
@@ -0,0 +1,197 @@
+Introduction to Blivet
+======================
+
+Blivet is a python module for system storage configuration.
+
+The main thing that blivet offers is the ability to model a series of changes
+without necessarily commiting any of the changes to disk. You can schedule an
+arbitrarily large series of changes (called 'actions'), seeing the effects of
+each (within the :class:`~.devicetree.DeviceTree` instance) as it is scheduled.
+Nothing is written to disk, however, until you execute the actions.
+
+Building Blocks
+===============
+
+Individual block devices are represented by the various subclasses of
+:class:`~.devices.StorageDevice`, while the formatting of the data they contain
+is represented by the various subclasses of :class:`~.formats.DeviceFormat`.
+The hierarchy of devices is represented by :class:`~.devicetree.DeviceTree`.
+
+:class:`~.devices.DiskDevice`, :class:`~.devices.PartitionDevice`,
+:class:`~.devices.LVMLogicalVolumeDevice`, and
+:class:`~.devices.MDRaidArrayDevice` are some of the most important examples of
+:class:`~.devices.StorageDevice` subclasses.
+
+Some examples of :class:`~.formats.DeviceFormat` subclasses include
+:class:`~.formats.swap.SwapSpace`, :class:`~.formats.disklabel.DiskLabel`,
+and subclasses of :class:`~.formats.fs.FS` such as :class:`~.formats.fs.Ext4FS`
+and :class:`~.formats.fs.XFS`.
+
+Every :class:`~.devices.StorageDevice` instance has a :attr:`~.devices.StorageDevice.format` that contains an instance of some :class:`~.formats.DeviceFormat`
+subclass -- even if it is "blank" or "unformatted" (in which case it is an instance of :class:`~.formats.DeviceFormat` itself).
+
+Every :class:`~.formats.DeviceFormat` has a
+:attr:`~.formats.DeviceFormat.device` attribute that is a string representing
+the path to the device node for the block device containing the formatting.
+:class:`~.devices.StorageDevice` and :class:`~.formats.DeviceFormat` can
+represent either existent or non-existent devices and formatting.
+
+:class:`~.devices.StorageDevice` and :class:`~.formats.DeviceFormat` share a similar API, which consists of methods to control existing devices/formats
+(:meth:`~.devices.StorageDevice.setup`,
+:meth:`~.devices.StorageDevice.teardown`), methods to create or modify
+devices/formats (:meth:`~.devices.StorageDevice.create`,
+:meth:`~.devices.StorageDevice.destroy`, :meth:`~.devices.StorageDevice.resize`)
+, and attributes to store critical data
+(:attr:`~.devices.StorageDevice.status`, :attr:`~.devices.StorageDevice.exists`)
+. Some useful attributes of :class:`~.devices.StorageDevice` that are not found
+in :class:`~.formats.DeviceFormat` include
+:attr:`~.devices.Device.parents`, :attr:`~.devices.Device.isleaf`,
+:attr:`~.devices.Device.ancestors`, and :attr:`~.devices.StorageDevice.disks`.
+
+:class:`~.devicetree.DeviceTree` provides
+:attr:`~.devicetree.DeviceTree.devices` which is a list of
+:class:`~.devices.StorageDevice` instances representing the current state of the
+system as configured within blivet. It also provides some methods for looking up
+devices (:meth:`~.devicetree.DeviceTree.getDeviceByName`), for listing devices
+that build upon a device (:meth:`~.devicetree.DeviceTree.getDependentDevices`),
+and for listing direct descendants of a given device
+(:meth:`~.devicetree.DeviceTree.getChildren`).
+
+Getting Started
+===============
+
+First Steps
+-----------
+
+First, create an instance of the :class:`~.Blivet` class::
+
+    import blivet
+    b = blivet.Blivet()
+
+Next, scan the system's storage configuration and store it in the tree::
+
+    b.reset()
+
+Now, you can do some simple things like listing the devices::
+
+    for device in b.devices:
+        print device
+
+To make changes to the configuration you'll schedule actions, but
+:class:`~.Blivet` provides some convenience methods to hide the details. Here's an example of removing partition '/dev/sda3'::
+
+    sda3 = b.devicetree.getDeviceByName("sda3")
+    b.destroyDevice(sda3)   # schedules actions to destroy format and device
+
+At this point, the StorageDevice representing sda3 is no longer in the tree.
+That means you could allocate a new partition from the newly free space if you
+wanted to (via blivet, that is, since there is not actually any free space on
+the physical disk yet -- you haven't commited the changes). If you now ran the
+following line::
+
+    sda3 = b.devicetree.getDeviceByName("sda3")
+
+sda3 would be None since that device has been removed from the tree.
+
+When you are ready to commit your changes to disk, here's how::
+
+    b.doIt()
+
+That's it. Now you have actually removed /dev/sda3 from the disk.
+
+Here's an alternative approach that uses the lower-level
+:class:`~.devicetree.DeviceTree` class directly::
+
+    import blivet
+    dt = blivet.devicetree.DeviceTree()
+    dt.populate()
+    sda3 = dt.getDeviceByName("sda3")
+    action1 = ActionDestroyFormat(sda3)
+    action2 = ActionDestroyDevice(sda3)
+    dt.registerAction(action1)
+    dt.registerAction(action2)
+    dt.processActions()
+
+Here's the Blivet approach again for comparison::
+
+    import blivet
+    b = blivet.Blivet() # contains a DeviceTree instance
+    b.reset()   # calls DeviceTree.populate()
+    sda3 = b.devicetree.getDeviceByName("sda3")
+    b.destroyDevice(sda3)   # schedules actions to destroy format and device
+    b.doIt()    # calls DeviceTree.processActions()
+
+
+Scheduling a Series of Actions
+------------------------------
+
+Start out as before::
+
+    import blivet
+    b = blivet.Blivet()
+    b.reset()
+    sda3 = b.devicetree.getDeviceByName("sda3")
+
+Now we're going to wipe the existing formatting from sda3::
+
+    b.destroyFormat(sda3)
+
+Now let's assume sda3 is larger than 10GB and resize it to that size::
+
+    b.resizeDevice(sda3, 10000) # size is in MB
+
+And then let's create a new ext4 filesystem there::
+
+    new_fmt = blivet.formats.getFormat("ext4", device=sda3.path)
+    b.formatDevice(sda3, new_fmt)
+
+If you want to commit the whole set of changes in one shot, it's easy::
+
+    b.doIt()
+
+Now you can mount the new filesystem at the directory "/mnt/test"::
+
+    sda3.format.setup(mountpoint="/mnt/test")
+
+Once you're finished, unmount it as follows::
+
+    sda3.format.teardown()
+
+
+Disk Partitions
+---------------
+
+Disk partitions are a little bit tricky in that they require an extra step to
+actually allocate the partitions from free space on the disk(s). What that
+means is deciding exactly which sectors on which disk the new partition will
+occupy. Blivet offers some powerful means for deciding for you where to place
+the partitions, but it also allows you to specify an exact start and end
+sector on a specific disk if that's how you want to do it. Here's an example
+of letting Blivet handle the details of creating a partition of minimum size
+10GB on either sdb or sdc that is also growable to a maximum size of 20GB::
+
+    sdb = b.devicetree.getDeviceByName("sdb")
+    sdc = b.devicetree.getDeviceByName("sdc")
+    new_part = b.newPartition(size=10000, grow=True, maxsize=20000,
+                              parents=[sdb, sdc])
+    b.createDevice(new_part)
+    blivet.partitioning.doPartitioning(b)
+
+Now you could see where it ended up::
+
+    print("partition %s of size %dMiB on disk %s" % (new_part.name,
+                                                     new_part.size,
+                                                     new_part.disk.name))
+
+From here, everything is the same as it was in the first examples. All that's
+left is to execute the scheduled action::
+
+    b.doIt()    # or b.devicetree.processActions()
+
+Backing up, let's see how it looks if you want to specify the start and end
+sectors. If you specify a start sector you have to also specify a single disk
+from which to allocate the partition::
+
+    new_part = b.newPartition(start=2048, end=204802048, parents=[sdb])
+
+All the rest is the same as the previous partitioning example.
diff --git a/doc/modules.rst b/doc/modules.rst
new file mode 100644
index 0000000..3910865
--- /dev/null
+++ b/doc/modules.rst
@@ -0,0 +1,7 @@
+Blivet
+======
+
+.. toctree::
+   :maxdepth: 4
+
+   blivet
-- 
1.8.1.4

